const { Field, config } = require('../index');

module.exports = class extends Field {
	
	constructor(hasAuto = false) {
		super()
		
		let choices = config('columnWidth');
		if (hasAuto) { choices.unshift(["auto", "Auto"]); }

		this.set('type',Field.choice().data.type)
			.name('column_width', 'Column Width')
			.choices(choices)
		
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}