let ColumnWidth = require('./ColumnWidth');

module.exports = class extends ColumnWidth {
	
	constructor() {
		super(true)
		this.name('content_width', 'Content Width')
			.inlineHelpText("Set width for section. Set as 'Auto' to calculate based on content width.")
			.default('auto')
		return this._build()
	}

	_build() {
		this.applyIf(!!this._filterChoices, (field) => field.choices(this.data.choices.filter(this._filterChoices)))
		return this
	}

	// --- Settings

	/**
	 * Usage:
	 * new Padding().filterChoices(c => (c[0] < 5))
	 */
	_filterChoices = false
	filterChoices(fn) { 
		this._filterChoices = typeof fn =='function' ? fn : null
		return this._build()
	}

}