const { Field, randomId } = require('../../index');
let GlobalGroup = require('../includes/GlobalGroup');

module.exports = class extends GlobalGroup {

	constructor() {
		super();
		this.name('swiper', 'Carousel Settings')
		this.autoplayId = randomId()
		this._build()
		return this
	}

	_build() {
		return this._buildChildrenArray(() => { 
			this.appendChildren(this.#standardFields())
		})
	}
	
	// --- Fields

	#standardFields() {
		return [
			Field
				.boolean()
				.name('enable', 'Enable Carousel')
				.set("display","toggle")
				.default(true),
			Field
				.boolean()
				.name('addPaginationArrows', 'Arrows')
				.set("display","toggle")
				.default(false),
			Field
				.boolean()
				.name('addPaginationDots', 'Dots')
				.set("display","toggle")
				.default(true),
			Field
				.boolean()
				.name('hideOverflow', 'Hide Overflow')
				.set("display","toggle")
				.default(false),
			Field
				.boolean()
				.name('loop', 'Loop Infinitely')
				.set("display","toggle")
				.default(true),
			Field
				.boolean()
				.name('centeredSlides', 'Centre Slides')
				.set("display","toggle")
				.default(false),
			Field
				.boolean()
				.name('autoplay', 'AutoPlay')
				.inlineHelpText('Autoplay speeed set to 3s by default.')
				.set("display","toggle")
				.default(false),
			Field
				.number()
				.set('min',1)
				.name('slidesPerView', 'Slider Per View')
				.default(3)
		]
	}

}