export const initScrollLinks = function () {

	//Check for anchor in URL
	setTimeout(() => {
		if (window.location.hash) {
			scrollToId(window.location.hash);
		}
	}, 2000);

	//Check for anchor links
	const aLinks = document.querySelectorAll('a[href^="#"]');
	aLinks.forEach((link) => {
		link.addEventListener('click', e => {
			const target = e.target;
			const href = target.getAttribute('href');
			e.preventDefault();
			scrollToId(href);
		});
	});
		
}

export const scrollToId = (id,offest = 0) => {
	const sectionID = id ? id.toString().replace('#', '') : '';
	if (!sectionID) { return; }
	const section = document.getElementById(sectionID);
	scrollToEl(section,offest)
}

export const scrollToEl = (el,offest = 0) => {
	if (el) {
		var originalPosition = el.style.position;
	  	el.style.position = "static";
		const totalOffset = el.getBoundingClientRect().top + window.pageYOffset;
		el.style.position = originalPosition || null;
		scrollTo(totalOffset - offest)
		var event = new CustomEvent('scrolledToSection', { el });
		window.dispatchEvent(event);
	}
}

export const scrollTo = (offest = 0) => {
	window.scrollTo({ top: offest, behavior: "smooth" });
}