const injectScripts = function (scripts = []) {
    let loaded = []

	scripts.forEach(s => {
		s = Object.assign({}, {
			type : '',
			src: '',
			precheck : null,
			onload : null
		}, s)
		
		// Checks
		if (!s.src) { return false; }
		if (['script', 'style'].indexOf(s.type) < 0) { return false; }
		
		// Callback Check
		if (!!s.precheck && typeof s.precheck == 'function') {
			if (!s.precheck({ type : s.type , src: s.src })) { 
				return false;
			}
		}
		
		// Script
		if (s.type == 'script') { 
			let script = document.createElement('script');
				script.setAttribute('src',s.src);
				document.head.appendChild(script);
			// Onload
			if (!!s.onload && typeof s.onload == 'function') { script.onload = s.onload }
			if (!!s.onerror && typeof s.onerror == 'function') { script.onerror = s.onerror }
		}

		// Styles
		if (s.type == 'style') {
			let style = document.createElement('link');
				style.setAttribute('rel',"stylesheet");
				style.setAttribute('type','text/css');
				style.setAttribute('href',s.src);
				document.head.appendChild(style);
			// Exit on Error
			style.onerror = () => { 
				console.log('Script not loaded')
				return false
			}
			// Onload
			if (!!s.onload && typeof s.onload == 'function') { s.onload(); }

		}
		
		// Add to Final array
		loaded.push(s)
	})
 
	return loaded
};

const checkAllObjectValuesAreTrue = function (object = {}) { 
	var loaded = Object.values(object);
	return (loaded.filter(v => !!v).length == loaded.length)
}

module.exports = {
	injectScripts,
	checkAllObjectValuesAreTrue
}